
! $Id: inifis.F90 1992 2014-03-05 13:19:12Z lguez $

SUBROUTINE inifis(ngrid, nlayer, punjours, pdayref, ptimestep, plat, plon, &
    parea, prad, pg, pr, pcpp)
  USE dimphy
  IMPLICIT NONE

  ! =======================================================================

  ! subject:
  ! --------

  ! Initialisation for the physical parametrisations of the LMD
  ! martian atmospheric general circulation modele.

  ! author: Frederic Hourdin 15 / 10 /93
  ! -------

  ! arguments:
  ! ----------

  ! input:
  ! ------

  ! ngrid                 Size of the horizontal grid.
  ! All internal loops are performed on that grid.
  ! nlayer                Number of vertical layers.
  ! pdayref               Day of reference for the simulation
  ! firstcall             True at the first call
  ! lastcall              True at the last call
  ! pday                  Number of days counted from the North. Spring
  ! equinoxe.

  ! =======================================================================

  ! -----------------------------------------------------------------------
  ! declarations:
  ! -------------

  ! ym#include "dimensions.h"
  ! ym#include "dimphy.h"

  include 'iniprint.h'
  REAL prad, pg, pr, pcpp, punjours

  INTEGER ngrid, nlayer
  REAL plat(ngrid), plon(ngrid), parea(klon)
  INTEGER pdayref

  REAL ptimestep
  CHARACTER (LEN=20) :: modname = 'inifis'
  CHARACTER (LEN=80) :: abort_message


  IF (nlayer/=klev) THEN
    PRINT *, 'STOP in inifis'
    PRINT *, 'Probleme de dimensions :'
    PRINT *, 'nlayer     = ', nlayer
    PRINT *, 'klev   = ', klev
    abort_message = ''
    CALL abort_gcm(modname, abort_message, 1)
  END IF

  IF (ngrid/=klon) THEN
    PRINT *, 'STOP in inifis'
    PRINT *, 'Probleme de dimensions :'
    PRINT *, 'ngrid     = ', ngrid
    PRINT *, 'klon   = ', klon
    abort_message = ''
    CALL abort_gcm(modname, abort_message, 1)
  END IF

  RETURN
  abort_message = 'Cette version demande les fichier rnatur.dat &
    &                                                         &
    &        et surf.def'
  CALL abort_gcm(modname, abort_message, 1)

END SUBROUTINE inifis
